﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr187_2
{
    // Объявление делегата с
    // аргументом x: 
    delegate double MyDelegate(double x);

    class Program
    {
        // Статический метод, вычисляющий 
        // значение квадратного трехчлена:
        static MyDelegate apply(double a, double b, double c)
        {
            // Лямбда-выражение, определяющее 
            // правило вычисления значения:
            return x => a * x * x + b * x + c;
        }

        static void Main()
        {
            // Значение x:
            double x = 2;
            // Значения коэффициентов:
            double a = 1, b = 2, c = 3;
            // Результат: 
            double d = apply(a, b, c)(x);
            // Вывод результата:
            Console.WriteLine("apply({0}, {1}, {2})({3}) = {4}", a, b, c, x, d);
            // Задержка:
            Console.ReadLine();
        }
    }
}
